package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class CyymallOrderDetailExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public CyymallOrderDetailExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNull() {
            addCriterion("order_id is null");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNotNull() {
            addCriterion("order_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrderIdEqualTo(Integer value) {
            addCriterion("order_id =", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotEqualTo(Integer value) {
            addCriterion("order_id <>", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThan(Integer value) {
            addCriterion("order_id >", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("order_id >=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThan(Integer value) {
            addCriterion("order_id <", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThanOrEqualTo(Integer value) {
            addCriterion("order_id <=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdIn(List<Integer> values) {
            addCriterion("order_id in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotIn(List<Integer> values) {
            addCriterion("order_id not in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdBetween(Integer value1, Integer value2) {
            addCriterion("order_id between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotBetween(Integer value1, Integer value2) {
            addCriterion("order_id not between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdEqualTo(Integer value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotEqualTo(Integer value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThan(Integer value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThan(Integer value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThanOrEqualTo(Integer value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIn(List<Integer> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotIn(List<Integer> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdBetween(Integer value1, Integer value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andNumIsNull() {
            addCriterion("num is null");
            return (Criteria) this;
        }

        public Criteria andNumIsNotNull() {
            addCriterion("num is not null");
            return (Criteria) this;
        }

        public Criteria andNumEqualTo(Integer value) {
            addCriterion("num =", value, "num");
            return (Criteria) this;
        }

        public Criteria andNumNotEqualTo(Integer value) {
            addCriterion("num <>", value, "num");
            return (Criteria) this;
        }

        public Criteria andNumGreaterThan(Integer value) {
            addCriterion("num >", value, "num");
            return (Criteria) this;
        }

        public Criteria andNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("num >=", value, "num");
            return (Criteria) this;
        }

        public Criteria andNumLessThan(Integer value) {
            addCriterion("num <", value, "num");
            return (Criteria) this;
        }

        public Criteria andNumLessThanOrEqualTo(Integer value) {
            addCriterion("num <=", value, "num");
            return (Criteria) this;
        }

        public Criteria andNumIn(List<Integer> values) {
            addCriterion("num in", values, "num");
            return (Criteria) this;
        }

        public Criteria andNumNotIn(List<Integer> values) {
            addCriterion("num not in", values, "num");
            return (Criteria) this;
        }

        public Criteria andNumBetween(Integer value1, Integer value2) {
            addCriterion("num between", value1, value2, "num");
            return (Criteria) this;
        }

        public Criteria andNumNotBetween(Integer value1, Integer value2) {
            addCriterion("num not between", value1, value2, "num");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIsNull() {
            addCriterion("total_price is null");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIsNotNull() {
            addCriterion("total_price is not null");
            return (Criteria) this;
        }

        public Criteria andTotalPriceEqualTo(BigDecimal value) {
            addCriterion("total_price =", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotEqualTo(BigDecimal value) {
            addCriterion("total_price <>", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceGreaterThan(BigDecimal value) {
            addCriterion("total_price >", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_price >=", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceLessThan(BigDecimal value) {
            addCriterion("total_price <", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_price <=", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIn(List<BigDecimal> values) {
            addCriterion("total_price in", values, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotIn(List<BigDecimal> values) {
            addCriterion("total_price not in", values, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_price between", value1, value2, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_price not between", value1, value2, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andAddtimeIsNull() {
            addCriterion("addtime is null");
            return (Criteria) this;
        }

        public Criteria andAddtimeIsNotNull() {
            addCriterion("addtime is not null");
            return (Criteria) this;
        }

        public Criteria andAddtimeEqualTo(Integer value) {
            addCriterion("addtime =", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeNotEqualTo(Integer value) {
            addCriterion("addtime <>", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeGreaterThan(Integer value) {
            addCriterion("addtime >", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeGreaterThanOrEqualTo(Integer value) {
            addCriterion("addtime >=", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeLessThan(Integer value) {
            addCriterion("addtime <", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeLessThanOrEqualTo(Integer value) {
            addCriterion("addtime <=", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeIn(List<Integer> values) {
            addCriterion("addtime in", values, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeNotIn(List<Integer> values) {
            addCriterion("addtime not in", values, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeBetween(Integer value1, Integer value2) {
            addCriterion("addtime between", value1, value2, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeNotBetween(Integer value1, Integer value2) {
            addCriterion("addtime not between", value1, value2, "addtime");
            return (Criteria) this;
        }

        public Criteria andIsDeleteIsNull() {
            addCriterion("is_delete is null");
            return (Criteria) this;
        }

        public Criteria andIsDeleteIsNotNull() {
            addCriterion("is_delete is not null");
            return (Criteria) this;
        }

        public Criteria andIsDeleteEqualTo(Short value) {
            addCriterion("is_delete =", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteNotEqualTo(Short value) {
            addCriterion("is_delete <>", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteGreaterThan(Short value) {
            addCriterion("is_delete >", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteGreaterThanOrEqualTo(Short value) {
            addCriterion("is_delete >=", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteLessThan(Short value) {
            addCriterion("is_delete <", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteLessThanOrEqualTo(Short value) {
            addCriterion("is_delete <=", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteIn(List<Short> values) {
            addCriterion("is_delete in", values, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteNotIn(List<Short> values) {
            addCriterion("is_delete not in", values, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteBetween(Short value1, Short value2) {
            addCriterion("is_delete between", value1, value2, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteNotBetween(Short value1, Short value2) {
            addCriterion("is_delete not between", value1, value2, "isDelete");
            return (Criteria) this;
        }

        public Criteria andPicIsNull() {
            addCriterion("pic is null");
            return (Criteria) this;
        }

        public Criteria andPicIsNotNull() {
            addCriterion("pic is not null");
            return (Criteria) this;
        }

        public Criteria andPicEqualTo(String value) {
            addCriterion("pic =", value, "pic");
            return (Criteria) this;
        }

        public Criteria andPicNotEqualTo(String value) {
            addCriterion("pic <>", value, "pic");
            return (Criteria) this;
        }

        public Criteria andPicGreaterThan(String value) {
            addCriterion("pic >", value, "pic");
            return (Criteria) this;
        }

        public Criteria andPicGreaterThanOrEqualTo(String value) {
            addCriterion("pic >=", value, "pic");
            return (Criteria) this;
        }

        public Criteria andPicLessThan(String value) {
            addCriterion("pic <", value, "pic");
            return (Criteria) this;
        }

        public Criteria andPicLessThanOrEqualTo(String value) {
            addCriterion("pic <=", value, "pic");
            return (Criteria) this;
        }

        public Criteria andPicLike(String value) {
            addCriterion("pic like", value, "pic");
            return (Criteria) this;
        }

        public Criteria andPicNotLike(String value) {
            addCriterion("pic not like", value, "pic");
            return (Criteria) this;
        }

        public Criteria andPicIn(List<String> values) {
            addCriterion("pic in", values, "pic");
            return (Criteria) this;
        }

        public Criteria andPicNotIn(List<String> values) {
            addCriterion("pic not in", values, "pic");
            return (Criteria) this;
        }

        public Criteria andPicBetween(String value1, String value2) {
            addCriterion("pic between", value1, value2, "pic");
            return (Criteria) this;
        }

        public Criteria andPicNotBetween(String value1, String value2) {
            addCriterion("pic not between", value1, value2, "pic");
            return (Criteria) this;
        }

        public Criteria andIntegralIsNull() {
            addCriterion("integral is null");
            return (Criteria) this;
        }

        public Criteria andIntegralIsNotNull() {
            addCriterion("integral is not null");
            return (Criteria) this;
        }

        public Criteria andIntegralEqualTo(Integer value) {
            addCriterion("integral =", value, "integral");
            return (Criteria) this;
        }

        public Criteria andIntegralNotEqualTo(Integer value) {
            addCriterion("integral <>", value, "integral");
            return (Criteria) this;
        }

        public Criteria andIntegralGreaterThan(Integer value) {
            addCriterion("integral >", value, "integral");
            return (Criteria) this;
        }

        public Criteria andIntegralGreaterThanOrEqualTo(Integer value) {
            addCriterion("integral >=", value, "integral");
            return (Criteria) this;
        }

        public Criteria andIntegralLessThan(Integer value) {
            addCriterion("integral <", value, "integral");
            return (Criteria) this;
        }

        public Criteria andIntegralLessThanOrEqualTo(Integer value) {
            addCriterion("integral <=", value, "integral");
            return (Criteria) this;
        }

        public Criteria andIntegralIn(List<Integer> values) {
            addCriterion("integral in", values, "integral");
            return (Criteria) this;
        }

        public Criteria andIntegralNotIn(List<Integer> values) {
            addCriterion("integral not in", values, "integral");
            return (Criteria) this;
        }

        public Criteria andIntegralBetween(Integer value1, Integer value2) {
            addCriterion("integral between", value1, value2, "integral");
            return (Criteria) this;
        }

        public Criteria andIntegralNotBetween(Integer value1, Integer value2) {
            addCriterion("integral not between", value1, value2, "integral");
            return (Criteria) this;
        }

        public Criteria andIsLevelIsNull() {
            addCriterion("is_level is null");
            return (Criteria) this;
        }

        public Criteria andIsLevelIsNotNull() {
            addCriterion("is_level is not null");
            return (Criteria) this;
        }

        public Criteria andIsLevelEqualTo(Short value) {
            addCriterion("is_level =", value, "isLevel");
            return (Criteria) this;
        }

        public Criteria andIsLevelNotEqualTo(Short value) {
            addCriterion("is_level <>", value, "isLevel");
            return (Criteria) this;
        }

        public Criteria andIsLevelGreaterThan(Short value) {
            addCriterion("is_level >", value, "isLevel");
            return (Criteria) this;
        }

        public Criteria andIsLevelGreaterThanOrEqualTo(Short value) {
            addCriterion("is_level >=", value, "isLevel");
            return (Criteria) this;
        }

        public Criteria andIsLevelLessThan(Short value) {
            addCriterion("is_level <", value, "isLevel");
            return (Criteria) this;
        }

        public Criteria andIsLevelLessThanOrEqualTo(Short value) {
            addCriterion("is_level <=", value, "isLevel");
            return (Criteria) this;
        }

        public Criteria andIsLevelIn(List<Short> values) {
            addCriterion("is_level in", values, "isLevel");
            return (Criteria) this;
        }

        public Criteria andIsLevelNotIn(List<Short> values) {
            addCriterion("is_level not in", values, "isLevel");
            return (Criteria) this;
        }

        public Criteria andIsLevelBetween(Short value1, Short value2) {
            addCriterion("is_level between", value1, value2, "isLevel");
            return (Criteria) this;
        }

        public Criteria andIsLevelNotBetween(Short value1, Short value2) {
            addCriterion("is_level not between", value1, value2, "isLevel");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsIsNull() {
            addCriterion("batch_price_tips is null");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsIsNotNull() {
            addCriterion("batch_price_tips is not null");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsEqualTo(String value) {
            addCriterion("batch_price_tips =", value, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsNotEqualTo(String value) {
            addCriterion("batch_price_tips <>", value, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsGreaterThan(String value) {
            addCriterion("batch_price_tips >", value, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsGreaterThanOrEqualTo(String value) {
            addCriterion("batch_price_tips >=", value, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsLessThan(String value) {
            addCriterion("batch_price_tips <", value, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsLessThanOrEqualTo(String value) {
            addCriterion("batch_price_tips <=", value, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsLike(String value) {
            addCriterion("batch_price_tips like", value, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsNotLike(String value) {
            addCriterion("batch_price_tips not like", value, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsIn(List<String> values) {
            addCriterion("batch_price_tips in", values, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsNotIn(List<String> values) {
            addCriterion("batch_price_tips not in", values, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsBetween(String value1, String value2) {
            addCriterion("batch_price_tips between", value1, value2, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andBatchPriceTipsNotBetween(String value1, String value2) {
            addCriterion("batch_price_tips not between", value1, value2, "batchPriceTips");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceIsNull() {
            addCriterion("supplier_price is null");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceIsNotNull() {
            addCriterion("supplier_price is not null");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceEqualTo(BigDecimal value) {
            addCriterion("supplier_price =", value, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceNotEqualTo(BigDecimal value) {
            addCriterion("supplier_price <>", value, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceGreaterThan(BigDecimal value) {
            addCriterion("supplier_price >", value, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("supplier_price >=", value, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceLessThan(BigDecimal value) {
            addCriterion("supplier_price <", value, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("supplier_price <=", value, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceIn(List<BigDecimal> values) {
            addCriterion("supplier_price in", values, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceNotIn(List<BigDecimal> values) {
            addCriterion("supplier_price not in", values, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("supplier_price between", value1, value2, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andSupplierPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("supplier_price not between", value1, value2, "supplierPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdIsNull() {
            addCriterion("vgoods_id is null");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdIsNotNull() {
            addCriterion("vgoods_id is not null");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdEqualTo(Integer value) {
            addCriterion("vgoods_id =", value, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdNotEqualTo(Integer value) {
            addCriterion("vgoods_id <>", value, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdGreaterThan(Integer value) {
            addCriterion("vgoods_id >", value, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("vgoods_id >=", value, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdLessThan(Integer value) {
            addCriterion("vgoods_id <", value, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdLessThanOrEqualTo(Integer value) {
            addCriterion("vgoods_id <=", value, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdIn(List<Integer> values) {
            addCriterion("vgoods_id in", values, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdNotIn(List<Integer> values) {
            addCriterion("vgoods_id not in", values, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdBetween(Integer value1, Integer value2) {
            addCriterion("vgoods_id between", value1, value2, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsIdNotBetween(Integer value1, Integer value2) {
            addCriterion("vgoods_id not between", value1, value2, "vgoodsId");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceIsNull() {
            addCriterion("vgoods_price is null");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceIsNotNull() {
            addCriterion("vgoods_price is not null");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceEqualTo(BigDecimal value) {
            addCriterion("vgoods_price =", value, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceNotEqualTo(BigDecimal value) {
            addCriterion("vgoods_price <>", value, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceGreaterThan(BigDecimal value) {
            addCriterion("vgoods_price >", value, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("vgoods_price >=", value, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceLessThan(BigDecimal value) {
            addCriterion("vgoods_price <", value, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("vgoods_price <=", value, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceIn(List<BigDecimal> values) {
            addCriterion("vgoods_price in", values, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceNotIn(List<BigDecimal> values) {
            addCriterion("vgoods_price not in", values, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("vgoods_price between", value1, value2, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVgoodsPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("vgoods_price not between", value1, value2, "vgoodsPrice");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdIsNull() {
            addCriterion("verify_card_sale_id is null");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdIsNotNull() {
            addCriterion("verify_card_sale_id is not null");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdEqualTo(Integer value) {
            addCriterion("verify_card_sale_id =", value, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdNotEqualTo(Integer value) {
            addCriterion("verify_card_sale_id <>", value, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdGreaterThan(Integer value) {
            addCriterion("verify_card_sale_id >", value, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("verify_card_sale_id >=", value, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdLessThan(Integer value) {
            addCriterion("verify_card_sale_id <", value, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdLessThanOrEqualTo(Integer value) {
            addCriterion("verify_card_sale_id <=", value, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdIn(List<Integer> values) {
            addCriterion("verify_card_sale_id in", values, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdNotIn(List<Integer> values) {
            addCriterion("verify_card_sale_id not in", values, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdBetween(Integer value1, Integer value2) {
            addCriterion("verify_card_sale_id between", value1, value2, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andVerifyCardSaleIdNotBetween(Integer value1, Integer value2) {
            addCriterion("verify_card_sale_id not between", value1, value2, "verifyCardSaleId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdIsNull() {
            addCriterion("give_goods_id is null");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdIsNotNull() {
            addCriterion("give_goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdEqualTo(Integer value) {
            addCriterion("give_goods_id =", value, "giveGoodsId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdNotEqualTo(Integer value) {
            addCriterion("give_goods_id <>", value, "giveGoodsId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdGreaterThan(Integer value) {
            addCriterion("give_goods_id >", value, "giveGoodsId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("give_goods_id >=", value, "giveGoodsId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdLessThan(Integer value) {
            addCriterion("give_goods_id <", value, "giveGoodsId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdLessThanOrEqualTo(Integer value) {
            addCriterion("give_goods_id <=", value, "giveGoodsId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdIn(List<Integer> values) {
            addCriterion("give_goods_id in", values, "giveGoodsId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdNotIn(List<Integer> values) {
            addCriterion("give_goods_id not in", values, "giveGoodsId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdBetween(Integer value1, Integer value2) {
            addCriterion("give_goods_id between", value1, value2, "giveGoodsId");
            return (Criteria) this;
        }

        public Criteria andGiveGoodsIdNotBetween(Integer value1, Integer value2) {
            addCriterion("give_goods_id not between", value1, value2, "giveGoodsId");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}